﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Collections;
using System.Data;
using System.Web.Script.Serialization;


public partial class _Default : System.Web.UI.Page
{
    /// <summary>
    /// 页面加载时
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void Page_Load(object sender, EventArgs e)
    {
        //判断是否异步请求
        if (Request.QueryString["ajax"] == "1")
        {
            ProcessRequest();
        }
    }

    /// <summary>
    /// 处理异步请求
    /// </summary>
    private void ProcessRequest()
    {
        Response.ContentType = "text/html";

        string json = Request.Form["json"];
        //反序列化DataTable
        DataTable newdtb = Json2Dtb(json);

        //序列化DataTable为JSON
        string back = Dtb2Json(newdtb);
        Response.Write(back);
        Response.End();
    }

    /// <summary>
    /// DataTable转Json
    /// </summary>
    /// <param name="dtb"></param>
    /// <returns></returns>
    private string Dtb2Json(DataTable dtb)
    {
        JavaScriptSerializer jss = new JavaScriptSerializer();
        ArrayList dic = new ArrayList();

        foreach (DataRow row in dtb.Rows)
        {
            Dictionary<string, object> drow = new Dictionary<string, object>();
            foreach (DataColumn col in dtb.Columns)
            {
                drow.Add(col.ColumnName, row[col.ColumnName]);
            }
            dic.Add(drow);
        }

        return jss.Serialize(dic);
    }

    /// <summary>
    /// Json转DataTable
    /// </summary>
    /// <param name="json"></param>
    /// <returns></returns>
    private DataTable Json2Dtb(string json)
    {
        JavaScriptSerializer jss = new JavaScriptSerializer();
        ArrayList dic = jss.Deserialize<ArrayList>(json);
        DataTable dtb = new DataTable();

        if (dic.Count > 0)
        {
            foreach (Dictionary<string, object> drow in dic)
            {
                if (dtb.Columns.Count == 0)
                {
                    foreach (string key in drow.Keys)
                    {
                        dtb.Columns.Add(key, drow[key].GetType());
                    }
                }

                DataRow row = dtb.NewRow();
                foreach (string key in drow.Keys)
                {

                    row[key] = drow[key];
                }
                dtb.Rows.Add(row);
            }
        }
        return dtb;
    }


}
